#pragma once
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include "time.h"
#include "math.h"

using namespace std;

const int SampleCount = 820;//
const int InCount = 2;//Ԫ
const int OutCount = 1;//Ԫ
const int HiddenCount = 45;//زԪ
const int TrainCount = 6000;//ѵ
const int LayerCount = 3;//
const int NeuronMax = 45;//ÿԪ(ҲֱӶ)

const double U0 = 0.15;
const double U1 = 0.0;//0.15
const double W_Rate = 0.8;//Ȩֵ//0.8
const double B_Rate = 0.8;//ֵ
const double Accuracy = 0.01;

#define ETA_W 0.2
#define ETA_B 0.1

class BP_network
{
public:
	BP_network();
	~BP_network();	
	void FwriteData();
	void FreadData();
	void Init_network();
	void Train_network();
	double Calculate(double x, double y);
private:
	double DataIn[SampleCount][InCount];//
	double DataOut[SampleCount][OutCount];//
	double w[LayerCount-1][HiddenCount][HiddenCount];//Ȩֵ(ΧΪֲ㣬ò)
	double b[LayerCount-1][NeuronMax];//ƫ(ڼ㣬ڼԪӦһԪ)
	double Yout[LayerCount-1][NeuronMax];//
	double inMax, outMax, inMin, outMin;
	double dv[HiddenCount][HiddenCount], dw[HiddenCount][HiddenCount];
	double db0[2][2], db1[HiddenCount][HiddenCount];


	double Sigmoid(double t);
	void DrivingOut(int i);
	void BackAdjust(int t);
	double Random();
};


